function export_avi(snimky, nazev) 

% CZ
% Tato funkce vyexportuje vstupn data videa v promnn snimky do formtu .avi pod nzvem v promnn nazev.
% Pouit: export_avi(snimky, nazev) 
% ------------------------------------------------------------------------------------------------------------------------------------------------------------
% EN
% This function exports input video data in variable snimky to .avi format under name in variable nazev.
% Use: export_avi(snimky, nazev) 
    
   % poten nastaven / initialization
   fig = figure;  
   set(gca,'xlim',[-80 80],'ylim',[-80 80],'NextPlot', 'replace','Visible','off');
   video = []; 
   
   pocet = size(snimky,3);
   
   minimum = min(min(min(snimky)));
   maximum = max(max(max(snimky)));
    
   % vytvoen RGB hodnot videa / creation of RGB video values
   for i=1:pocet
        imagesc(abs(snimky(:,:,i)),[minimum maximum])
        axis image off
        colormap gray
        F = getframe(gca);
        video = cat(4,video,F.cdata); 
   end

   close(fig);

   % export videa do .avi / export of video to .avi
   myVideo = VideoWriter(strcat(nazev,'.avi'));
   open(myVideo);
   writeVideo(myVideo, video);
   close(myVideo);
  
end