clear; clc; close all;
    
procento = 99; % kolik vynulujeme nejmench vzork ve spektru
barva = ['k','c','r','g','b','m']'; % barvy grafu

% parametry pro lognormln model / parameters to lognormal model
t0 =1; % posunut lognormlnho rozdlen / shift of lognormal distribution
% parametry lognormlnho rozdlen  (2x) / parameters of  lognormal distribution (2x)
mi =  [ 3 4 5 6 7 8 ]';
sigma = 0.7;    
S = 8.6*10^6; % plocha pod grafem (stejn pro ob hustoty) / area under curve (same for both)
% pedpokld se, e doba sledovn a frekvence jsou soudln / it is assumed that duration of observation and frequency are divisible
T = 600; % doba sledovn / duration of observation
f = 1; % frekvence / frequency

%% vpoet pro konstantn sigma
graf = zeros(length(mi),1);

for i = 1:length(mi)
    fx = lognormal_model(t0, mi(i), sigma, S, T, f);
    
    % spektrum lognormlnho modelu
    fourfx = fft(fx);
    
    graf(i) = plot(fftshift(abs(fourfx)),barva(mod(i,length(barva))+1));
    hold on;
    plot(fftshift(abs(fourfx)),barva(mod(i,length(barva))+1));
end

legenda = legend(graf,num2str(mi));
set(legenda,'Location','NorthEastOutside');
title(['absolutn hodnota spektra lognormlnho modelu pro rzn nastaven mi pi sigma =  ',num2str(sigma)]);

%% vpoet pro konstantn mi
mi = 5.5;
sigma = [0.5 1 1.5 2 2.5]'; 

graf = zeros(length(mi),1);
figure

for i = 1:length(sigma)
    fx = lognormal_model(t0, mi, sigma(i), S, T, f);
    
    % spektrum lognormlnho modelu
    fourfx = fft(fx);
    
    graf(i) = plot(fftshift(abs(fourfx)),barva(mod(i,length(barva))+1));
    hold on;
    plot(fftshift(abs(fourfx)),barva(mod(i,length(barva))+1));
end

legenda = legend(graf,num2str(sigma));
set(legenda,'Location','NorthEastOutside');
title(['absolutn hodnota spektra lognormlnho modelu pro rzn nastaven sigma pi mi =  ',num2str(mi)]);

%% vymazn nejmench koeficient
sigma = 0.7;  

fx = lognormal_model(t0, mi, sigma, S, T, f);
spektrum = fft(fx);
pom = sort(abs(spektrum));
hranice = pom(T*f*procento/100);
A = (abs(spektrum) > hranice);
spektrum = spektrum.*A;
fx2 = ifft(spektrum);

figure
plot(fftshift(abs(fft(fx))))
hold on
plot(fftshift(abs(spektrum)),'r')

legenda = legend('pvodn', 'ozl');
set(legenda,'Location','NorthEastOutside');
title(['porovnn pvodnho spektra lognormln kivky s oznutm spektrem, oznuto  ',num2str(procento), ' % nejmench koef.']);

figure
plot(fx)
hold on
plot(fx2,'r')

legenda = legend('pvodn', 'ozl');
set(legenda,'Location','NorthEastOutside');
title(['porovnn pvodn lognormln kivky s oznutou ve spektru, oznuto  ',num2str(procento), ' % nejmench koef.']);